<?php
//Includes
include 'time.php';
include 'guest_auth.php';
include 'functions.php';
include 'connect_db.php';


// Define Variables
$Message = "";
$emailErr = $EMail = $name = $nameErr = $pass = $passErr = $Login_Count = $Statement = $FailedLogins = $SiteLocked = "";
$error_count = 0;

// Check if form has been submitted and do login if TRUE
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    // Define variables
    $Username_Try = $_POST["Username"];
    $Password_Try = $_POST["Password"];
    $LastLoginIP = getUserIP();
    //Check for Empty fields on sitename
    if (empty($_POST["Username"])) {
        $nameErr = "</br><font face=arial size=2 color=#1F4967>Name is required </br>";
        $error_count++;
    } else {
        $name = test_input($_POST["Username"]);
        // check if name only contains letters and whitespace
        if (!preg_match("^[A-Za-z]{5,25}$^", $name)) {
            $nameErr = "</br><font face=arial size=2 color=#1F4967>Site name must containt 5 A - Z characters minimum no spaces";
            $error_count++;
        }
    }
    //Check for Empty fields on passwords
    if (empty($_POST["Password"])) {
        $passErr = "</br><font face=arial size=2 color=#1F4967>Password is required</br>";
        $error_count++;
    } else {
        $pass = test_input($_POST["Password"]);
        // check if name only contains letters and whitespace
        if (!preg_match("^(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{8,16}$^", $pass)) {
            $passErr = "</br><font face=arial size=2 color=#1F4967>Password must include at least one upper case letter</br>one lower case letter, and one numeric digit</br>";
            $error_count++;
        }
    }
    if ($error_count == 0) {
        // Select Username if Username_Try matches
        if ($data = $mysqli->prepare("SELECT Username, Password, MFASecret FROM Users WHERE Username = ? LIMIT 1")) {
            $data->bind_param('s', $Username_Try);
            $data->execute();
            $data->store_result();
            $data->bind_result($Username, $Password, $MFASecret);
            $data->fetch();

            //Check if supplied Site Name details match ie does a site name return a row
            if ($data->num_rows == 1) { //Site Name must be correct as 1 row has been returned
                //Check if supplied password details match
                if (password_verify($Password_Try, $Password)) {
                    //GOOD PASSWORD
                    //Get Site Locked out status
                    if ($data = $mysqli->prepare("SELECT SiteLocked FROM Users WHERE Username = ? LIMIT 1")) {
                        $data->bind_param('s', $Username);
                        $data->execute();
                        $data->store_result();
                        $data->bind_result($SiteLocked);
                        $data->fetch();
                    } //Close for Get Site Locked out status
                    //Check if site is locked out
                    if ($SiteLocked == "Yes") {
                        //SITE IS LOCKED
                        //Get Site LockoutDate
                        if ($data = $mysqli->prepare("SELECT LockoutDate FROM Users WHERE Username = ? LIMIT 1")) {
                            $data->bind_param('s', $Username);
                            $data->execute();
                            $data->store_result();
                            $data->bind_result($LockoutDate);
                            $data->fetch();
                        } //Close for Get Site LockoutDate
                        //Calculate time difference in hours
                        $LockedOutPeriod = round((strtotime($Time) - strtotime($LockoutDate)) / (60 * 60));
                        //Is Lockout period > 2 Hours
                        if ($LockedOutPeriod > 2) {

                          //Collect Site MFA Status
                          if ($data = $mysqli->prepare("SELECT MFASecret FROM Users WHERE Username = ? LIMIT 1")) {
                              $data->bind_param('s', $Username);
                              $data->execute();
                              $data->store_result();
                              $data->bind_result($MFASecret);
                              $data->fetch();
                              $data->close();
                          } else { //Else For Create the new host
                            $Message = "<font face=arial size=2 color=#1F4967>2 There has been an SQL error, if this problem persists please seek technical assistance</font>";
                          }

                          //Is 2FA Enabled or Disabled
                          if (is_null($MFASecret)) {
                            //MFA is Disabled
                            //RESET LOCKED ACCOUNT DETAILS AND LOGIN
                            //NULL LockoutDate
                            if ($data = $mysqli->prepare("UPDATE Users SET LockoutDate = NULL, SiteLocked = NULL, FailedLogins = NULL, LastLoginIP = ?, LastLogin = ? WHERE Username = ? LIMIT 1")) {
                                $data->bind_param('sss', $LastLoginIP, $DateTime, $Username);
                                $data->execute();
                            } //Close for NULL LockoutDate
                            //Set Session and Redirect to Status Page
                            //Set session Username
                            $_SESSION['Username'] = $Username;
                            //Process Account_Type
                            if ($Username == "Admin") {
                                //Set session Account_Type
                                $_SESSION['Account_Type'] = "Admin";
                                //Redirect to Status Page
                                echo '<meta http-equiv="refresh" content="0; URL=admin.php">';
                            } else {
                                //Set session Account_Type
                                $_SESSION['Account_Type'] = "User";
                                //Redirect to Status Page
                                echo '<meta http-equiv="refresh" content="0; URL=members.php">';
                            }
                          } else {
                            //MFA is Enabled
                            $_SESSION['2FA_Temp_Username'] = $Username;
                            echo '<meta http-equiv="refresh" content="0; URL=2fa_check.php">';
                          }

                        } else { //Else for Is Lockout period > 2 Hours
                            //LOCKED OUT PERIOD IS < 2 HOURS, SITE IS TO REMAIN LOCKED
                            $Message = "<font face=arial size=2 color=#1F4967>Sorry, your account is currently locked.</font>";
                        } //Close for Is Lockout period > 2 Hours
                    } else { //Else for if site locked is Yes
                        //SITE IS NOT LOCKED
                        //Collect Site MFA Status
                          if ($data = $mysqli->prepare("SELECT MFASecret FROM Users WHERE Username = ? LIMIT 1")) {
                              $data->bind_param('s', $Username);
                              $data->execute();
                              $data->store_result();
                              $data->bind_result($MFASecret);
                              $data->fetch();
                              $data->close();
                          } else { //Else For Create the new host
                            $Message = "<font face=arial size=2 color=#1F4967>2 There has been an SQL error, if this problem persists please seek technical assistance</font>";
                          }

                          //Is 2FA Enabled or Disabled
                          if (is_null($MFASecret)) {
                            //MFA is Disabled
                            //RESET LOCKED ACCOUNT DETAILS AND LOGIN
                            //NULL LockoutDate
                            if ($data = $mysqli->prepare("UPDATE Users SET LockoutDate = NULL, SiteLocked = NULL, FailedLogins = NULL, LastLoginIP = ?, LastLogin = ? WHERE Username = ? LIMIT 1")) {
                                $data->bind_param('sss', $LastLoginIP, $DateTime, $Username);
                                $data->execute();
                            } //Close for NULL LockoutDate
                            //Set Session and Redirect to Status Page
                            //Set session Username
                            $_SESSION['Username'] = $Username;
                            //Process Account_Type
                            if ($Username == "Admin") {
                                //Set session Account_Type
                                $_SESSION['Account_Type'] = "Admin";
                                //Redirect to Status Page
                                echo '<meta http-equiv="refresh" content="0; URL=admin.php">';
                            } else {
                                //Set session Account_Type
                                $_SESSION['Account_Type'] = "User";
                                //Redirect to Status Page
                                echo '<meta http-equiv="refresh" content="0; URL=members.php">';
                            }
                          } else {
                            //MFA is Enabled
                            $_SESSION['2FA_Temp_Username'] = $Username;
                            echo '<meta http-equiv="refresh" content="0; URL=2fa_check.php">';
                          }
                    } //Close for if site locked is Yes
                } else { //Else for Check if supplied password details match
                    //BAD PASSWORD
                    //Get Site Locked out status
                    if ($data = $mysqli->prepare("SELECT SiteLocked FROM Users WHERE Username = ? LIMIT 1")) {
                        $data->bind_param('s', $Username);
                        $data->execute();
                        $data->store_result();
                        $data->bind_result($SiteLocked);
                        $data->fetch();
                    } //Close for Get Site Locked out status
                    //Check if site is locked out
                    if ($SiteLocked == "Yes") {
                        //SITE IS LOCKED
                        $Message = "<font face=arial size=2 color=#1F4967>Sorry, your account is currently locked.</font>";
                    } else { //Else for if site locked is Yes
                        //SITE IS NOT LOCKED
                        //Get Current Failed Login's
                        if ($data = $mysqli->prepare("SELECT FailedLogins FROM Users WHERE Username = ? LIMIT 1")) {
                            $data->bind_param('s', $Username);
                            $data->execute();
                            $data->store_result();
                            $data->bind_result($FailedLogins);
                            $data->fetch();
                        } //Close for Get Current Failed Login's
                        //Check if Failed Logins >= 3
                        if ($FailedLogins >= 3) {
                            //Set LockoutDate to current timestamp
                            if ($data = $mysqli->prepare("UPDATE Users SET LockoutDate = ?, SiteLocked = 'Yes' WHERE Username = ? LIMIT 1")) {
                                $data->bind_param('ss', $DateTime, $Username);
                                $data->execute();
                            } //Close for Set LockoutDate to current timestamp
                            //SITE IS LOCKED
                            $Message = "<font face=arial size=2 color=#1F4967>Sorry, your account is currently locked.</font>";
                        } else { //Else for Check if Failed Login's >= 3
                            //Increment Failed Login's +1
                            $FailedLogins++;
                            //Update Failed Logins
                            if ($data = $mysqli->prepare("UPDATE Users SET FailedLogins = ? WHERE Username = ? LIMIT 1")) {
                                $data->bind_param('is', $FailedLogins, $Username);
                                $data->execute();
                            } //Close for Update Failed Login's
                            //Report Incorrect Login to User
                            $Message = "<font face=arial size=2 color=#1F4967>Incorrect Login, please try again.</br>
                            <a href=forgot_user.php>
                              <span style=font-size:12pt;font-family:&quot;Tahoma&quot;,sans-serif;color:#1F4967;font-weight:normal>Forgot Username <o:p></o:p></span>
                            </a>
                            <a href=forgot_pass.php>
                              <span style=font-size:12pt;font-family:&quot;Tahoma&quot;,sans-serif;color:#1F4967;font-weight:normal>| Forgot Password?<o:p></o:p></span>
                            </a>
                            </font>";
                        } //Close for Check if Failed Login's >= 3
                    } //Close for if site locked is Yes
                } //Close for Check if supplied password details match
            } else {//Else for Check if supplied Site Name details match ie does a site name return a row
                $Message = "<font face=arial size=2 color=#1F4967>Incorrect Login, please try again.</br>
                <a href=forgot_user.php>
                  <spanstyle=font-size:12pt;font-family:&quot;Tahoma&quot;,sans-serif;color:#1F4967;font-weight:normal>Forgot Username <o:p></o:p></span>
                </a>
                <a href=forgot_pass.php>
                  <span style=font-size:12pt;font-family:&quot;Tahoma&quot;,sans-serif;color:#1F4967;font-weight:normal>| Forgot Password?<o:p></o:p></span>
                </a>
                </font>";
            }//Close for Check if supplied Site Name details match ie does a site name return a row
            //Close the MySQL Data Connection
            //$data->close();
        } else { //Else for Select Username if Username_Try matches
            //SITE NAME INCORRECT
            //Report Incorrect Login to User
            $Message = "<font face=arial size=2 color=#1F4967>Incorrect Login, please try again.</br>
            <a href=forgot_user.php>
              <spanstyle=font-size:12pt;font-family:&quot;Tahoma&quot;,sans-serif;color:#1F4967;font-weight:normal>Forgot Username <o:p></o:p></span>
            </a>
            <a href=forgot_pass.php>
              <span style=font-size:12pt;font-family:&quot;Tahoma&quot;,sans-serif;color:#1F4967;font-weight:normal>| Forgot Password?<o:p></o:p></span>
            </a>
            </font>";
        } //Close for Select Username if Username_Try matches
    } //Close if Error Count == 0
} //Close if ($_SERVER["REQUEST_METHOD"] == "POST") {
?>
<html>
<head>
    <title>Login System</title>
    <link href="style.css" rel="stylesheet" type="text/css">
</head>
<body bgcolor="#ffffff">
<center>
    <img src="images/LoginSystem.png" alt="Login System" width=400 height=132>
    <form method="post" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]); ?>">
        <td align="center">
        <input type="text" name="Username" value="<?php echo $name; ?>" title="Please enter your username, 5 characters minimum." placeholder="Username">
      <P>
        <input type="password" name="Password" autocomplete="off" value="<?php echo $pass; ?>" title="Password must include at least one upper case letter</br>one lower case letter, and one numeric digit" placeholder="Password">
      <P>
        <input type="submit" value="Login">
      <P>
        </td>

        </tr>
        </table>

        <?php echo $nameErr; ?>
        <?php echo $passErr; ?>
        <?php echo $Message; ?>
    </form>

    <a href="signup.php"><span style="font-size:12pt;font-family:&quot;Tahoma&quot;,sans-serif;color:#1F4967;font-weight:normal">Signup here for free!<o:p></o:p></span></a>
</center>
</body>
</html>
